apiVersion: apps/v1
kind: Deployment
metadata:
  name: "{{ template "app.name" . }}"
  namespace: {{ .Release.Namespace }}
  labels:
    {{- include "app.labels" . | nindent 4 }}
spec:
  replicas: {{ .Values.replicaCount }}
  strategy:
    type: RollingUpdate
    rollingUpdate:
      maxSurge: 1
      maxUnavailable: 0
  selector:
    matchLabels:
      {{- include "app.selectorLabels" . | nindent 6 }}
  template:
    metadata:
      labels:
        {{- include "app.labels" . | nindent 8 }}
      annotations:
{{- if .Values.podAnnotations }}
{{ toYaml .Values.podAnnotations | indent 8 }}
{{- end }}
    spec:
      {{- if .Values.serviceAccountName }}
      serviceAccountName: {{ .Values.serviceAccountName }}
      {{- end }}
      imagePullSecrets:
        - name: {{ .Values.image.pullSecrets }}
      containers:
      - name: {{ .Chart.Name }}
        image: "{{ .Values.image.repository }}/{{ .Values.image.name }}:{{ default .Chart.AppVersion .Values.image.tag }}"
        imagePullPolicy: {{ .Values.image.pullPolicy | quote }}
        env: 
          - name: "RESOLVER"
            value: {{ .Values.config.RESOLVER }}
          - name: "PROOF_OCM"
            value: {{ .Values.config.PROOF_OCM }}
          - name: "CM_OCM"
            value: {{ .Values.config.CM_OCM }}
          - name: "OAUTH2_CLIENT_PROVIDER_OIDC_ISSUER"
            value: {{ .Values.config.OAUTH2_CLIENT_PROVIDER_OIDC_ISSUER }}
          - name: "OAUTH2_CLIENT_PROVIDER_OIDC_JWKS"
            value: {{ .Values.config.OAUTH2_CLIENT_PROVIDER_OIDC_JWKS }}
          - name: "CATALOGSERVICE_CLIENTID"
            value: {{ .Values.config.CATALOGSERVICE_CLIENTID }}
          - name: CATALOGSERVICE_CLIENT_SECRET
            valueFrom:
              secretKeyRef:
                name: {{ include "app.fullname" . }}-catalog-client-secret
                key: {{ .Values.config.CATALOGSERVICE_CLIENT_SECRET }}
          - name: "CATALOGSERVICE_USERNAME"
            value: {{ .Values.config.createAdminRolePath }}
          - name: CATALOGSERVICE_PASSWORD
            valueFrom:
              secretKeyRef:
                name: {{ include "app.fullname" . }}-catalog-service-password
                key: {{ .Values.config.CATALOGSERVICE_PASSWORD }}
          - name: "CATALOGSERVICE_TOKENURL"
            value: {{ .Values.config.CATALOGSERVICE_TOKENURL }}
          - name: "CATALOG_ENDPOINT"
            value: {{ .Values.config.CATALOG_ENDPOINT }}
        ports:
        - name: http
          containerPort: {{ .Values.server.http.port }}
        readinessProbe:
          httpGet:
            path: /isAlive
            port: {{ .Values.server.http.port }}
          initialDelaySeconds: 5
          periodSeconds: 5
          successThreshold: 2
          failureThreshold: 2
          timeoutSeconds: 5
